diff -ruN gcc-15.1.0.orig/libgcc/config/rs6000/gthr-morphos.c gcc-15.1.0/libgcc/config/rs6000/gthr-morphos.c
--- gcc-15.1.0.orig/libgcc/config/rs6000/gthr-morphos.c	1970-01-01 02:00:00.000000000 +0200
+++ gcc-15.1.0/libgcc/config/rs6000/gthr-morphos.c	2025-04-25 15:58:40.280619963 +0300
@@ -0,0 +1,2321 @@
+/* Threads compatibility routines for libgcc2.  */
+/* Compile this one with gcc.  */
+/* Copyright (C) 1997, 1999, 2000, 2004, 2008, 2009
+   Free Software Foundation, Inc.
+   Copyright (C) 2016-2020 Harry Sintonen
+
+This file is part of GCC.
+
+GCC is free software; you can redistribute it and/or modify it under
+the terms of the GNU General Public License as published by the Free
+Software Foundation; either version 3, or (at your option) any later
+version.
+
+GCC is distributed in the hope that it will be useful, but WITHOUT ANY
+WARRANTY; without even the implied warranty of MERCHANTABILITY or
+FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+for more details.
+
+Under Section 7 of GPL version 3, you are granted additional
+permissions described in the GCC Runtime Library Exception, version
+3.1, as published by the Free Software Foundation.
+
+You should have received a copy of the GNU General Public License and
+a copy of the GCC Runtime Library Exception along with this program;
+see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
+<http://www.gnu.org/licenses/>.  */
+
+#include "gthr-morphos.h"
+#include <string.h>
+
+#ifndef GCC_SYSTEM_H
+#if defined(__GNUC__) && GCC_VERSION > 4000
+/* GCC 4.0.x has a bug where it may ICE on this expression,
+   so does GCC 3.4.x (PR17436).  */
+#define CONST_CAST2(TOTYPE,FROMTYPE,X) ((__extension__(union {FROMTYPE _q; TOTYPE _nq;})(X))._nq)
+#else
+#define CONST_CAST2(TOTYPE,FROMTYPE,X) ((TOTYPE)(FROMTYPE)(X))
+#endif
+#define CONST_CAST(TYPE,X) CONST_CAST2(TYPE, const TYPE, (X))
+#endif
+
+#ifndef __ATTR_WEAK_ALIAS
+#define __ATTR_WEAK_ALIAS(_f_) __attribute__ ((weak, alias (#_f_)))
+#endif
+
+#ifndef __ATTR_WEAK
+#define __ATTR_WEAK __attribute__ ((weak))
+#endif
+
+#ifndef HIDE_EXPORTS
+#pragma GCC visibility push(default)
+#endif
+
+/*
+ * MorphOS threading
+ */
+
+#define USE_THREAD_ONLY_SETSPECIFIC 0 /* 1 -> Do not allow __gthread_setspecific for non-thread callers */
+#define USE_THREAD_SAFETYNET        1 /* 1 -> Have an atexit function to join all pending threads */
+
+/* Custom SysBase we need for memory, semaphores, etc */
+#define USE_INLINE_STDARG
+#define __NOLIBBASE__
+#include <exec/tasks.h>
+#define EXEC_BASE_NAME ABOX_GETTASKSYSBASE
+#define __IXEMUL_EXEC_MIXING_ALLOWED
+
+#include <proto/exec.h>
+#include <proto/dos.h>
+#include <hardware/atomic.h>
+#include <exec/memory.h>
+#include <exec/semaphores.h>
+#include <exec/rawfmt.h>
+#include <devices/timer.h>
+#include <dos/dostags.h>
+#define EXEC_SILENT_BUILD 1
+#include <exec/avl.h>
+#include <clib/savl_protos.h>
+#include <stddef.h>
+#include <stdlib.h>
+#if USE_THREAD_SAFETYNET
+extern struct Library *SocketBase; /* Make unistd.h select() inline not croak */
+#include <unistd.h>
+#endif
+#include <signal.h>
+#ifdef __ixemul
+#include <workbench/startup.h>
+#include <exec/interrupts.h>
+
+#include <stdio.h>
+#include <ix.h>
+
+/*
+ * ixemul internal structures as they were during ixemul <= 50.17.
+ * This stuff is needed to ensure that the fallback code will continue
+ * to build with the same offsets regardless of the potential future
+ * changes to the ixemul internal structures. This stuff is not used
+ * if the new ixemul.library 50.18+ is available. - Piru
+ */
+#define DTYPE_SOCKET50 5
+
+struct ixnode50 {
+  struct ixnode *next, *prev;
+};
+
+struct ixlist50 {
+  struct ixnode *head, *tail;
+};
+
+struct utimenode50 {
+  struct ixnode50 node;
+  unsigned time;
+};
+
+struct glue50 {
+        struct  glue50 *next;
+        int     niobs;
+        void    *iobs;
+};
+
+struct malloc_data50 {
+  struct ixlist50 md_list;
+  unsigned int md_malloc_sbrk_used;
+};
+
+struct stackframe;
+struct session50 {
+	int     s_count;
+};
+
+#ifdef __PPC__
+#define _JBLEN50  (7+19+2*18+14+3*6)
+#else
+#define _JBLEN50  17
+#endif
+typedef int jmp_buf50[_JBLEN50];
+
+typedef long time50_t;
+
+struct timeval50 {
+        long    tv_sec;
+        long    tv_usec;
+};
+
+struct itimerval50 {
+        struct  timeval50 it_interval;
+        struct  timeval50 it_value;
+};
+
+struct rusage50 {
+        struct timeval50 ru_utime;
+        struct timeval50 ru_stime;
+        long    ru_maxrss;
+        long    ru_ixrss;
+        long    ru_idrss;
+        long    ru_isrss;
+        long    ru_minflt;
+        long    ru_majflt;
+        long    ru_nswap;
+        long    ru_inblock;
+        long    ru_oublock;
+        long    ru_msgsnd;
+        long    ru_msgrcv;
+        long    ru_nsignals;
+        long    ru_nvcsw;
+        long    ru_nivcsw;
+};
+
+struct rlimit50 {
+        long    rlim_cur;
+        long    rlim_max;
+};
+
+struct mem_file50 {
+  int   mf_offset;
+  void *mf_buffer;
+};
+
+struct file50 {
+  char *f_name;
+  int f_stb_dirty,
+      f_type,
+      f_flags,
+      f_count,
+      (*f_write)(),
+      (*f_read)(),
+      (*f_ioctl)(),
+      (*f_select)(),
+      (*f_close)();
+  union {
+    struct {
+        int so;
+        int domain;
+        int type;
+        int protocol;
+        long id;
+    } inetsock;
+  } f__fh;
+};
+
+#define f_socket_domain f__fh.inetsock.domain
+#define f_socket_type f__fh.inetsock.type
+#define f_socket_protocol f__fh.inetsock.protocol
+#define f_socket_id f__fh.inetsock.id
+
+typedef char *caddr50_t;
+
+struct sigstack50 {
+        char    *ss_sp;
+        int     ss_onstack;
+};
+
+typedef void (*sig50_t)(int);
+typedef unsigned int sigset50_t;
+
+struct passwd50 {
+        char    *pw_name;
+        char    *pw_passwd;
+        int     pw_uid;
+        int     pw_gid;
+        time50_t pw_change;
+        char    *pw_class;
+        char    *pw_gecos;
+        char    *pw_dir;
+        char    *pw_shell;
+        time50_t pw_expire;
+};
+
+struct group50 {
+        char    *gr_name;
+        char    *gr_passwd;
+        int     gr_gid;
+        char    **gr_mem;
+};
+
+struct servent50 {
+        char    *s_name;
+        char    **s_aliases;
+        int     s_port;
+        char    *s_proto;
+};
+
+struct protoent50 {
+        char    *p_name;
+        char    **p_aliases;
+        int     p_proto;
+};
+
+struct netent50 {
+        char            *n_name;
+        char            **n_aliases;
+        int             n_addrtype;
+        unsigned long   n_net;
+};
+
+typedef int32_t pid50_t;
+
+typedef unsigned short uid50_t;
+typedef unsigned short gid50_t;
+
+#define NOFILE50 512
+
+struct user50 {
+	/* both a magic cookie and a way to get at the library base thru u */
+	void                    *u_ixbase;
+	void                    *u_user;        /* freely usable user field */
+
+	long            u_a4_pointers_size;     /* number of a4 pointers */
+
+/* 1.3 - signal management */
+	sig50_t         u_signal[33];           /* disposition of signals */
+	int             u_sigmask[33];          /* signals to be blocked */
+	sigset50_t      u_sigonstack;           /* signals to take on sigstack */
+	sigset50_t      u_sigintr;              /* signals that interrupt syscalls */
+	sigset50_t      u_oldmask;              /* saved mask from before sigpause */
+	struct sigstack50 u_sigstack;    /* sp & on stack state variable */
+	int             u_sig;                  /* for core dump/debugger XXX */
+	int             u_code;                 /* for core dump/debugger XXX */
+
+	int                     p_flag;         /* process flags, as necessary.. */
+	int                     p_xstat;        /* exit status */
+	char                    p_stat;
+	char                    p_cursig;
+	short                   pad;
+	sigset50_t              p_sig;          /* signals pending to this process */
+	sigset50_t              p_sigmask;      /* current signal mask */
+	sigset50_t              p_sigignore;    /* signals being ignored */
+	sigset50_t              p_sigcatch;     /* signals being caught by user */
+
+	caddr50_t               p_wchan;        /* event process is awaiting */
+
+
+/* 1.4 - descriptor management (for shared library version) */
+	struct file50           *u_ofile[NOFILE50];       /* file structures for open files */
+	char                    u_pofile[NOFILE50];       /* per-process flags of open files */
+	int                     u_lastfile;     /* high-water mark of u_ofile */
+	short                   u_cmask;        /* mask for file creation */
+
+/* 1.5 - timing and statistics */
+	struct rusage50         u_ru;           /* stats for this proc */
+	struct rusage50         u_cru;          /* sum of stats for reaped children */
+	struct itimerval50      u_timer[3];
+	struct timeval50        u_start;
+	struct utimenode50      u_time;
+	short                   u_acflag;
+
+	struct uprof50 {                /* profile arguments */
+		short   *pr_base;       /* buffer base */
+		unsigned pr_size;       /* buffer size */
+		unsigned pr_off;        /* pc offset */
+		unsigned pr_scale;      /* pc scaling */
+	} u_prof;
+	unsigned                u_prof_last_pc; /* last function that called mcount() */
+
+/* 1.6 - resource controls */
+	struct rlimit50 u_rlimit[9];
+
+/* amiga specific stuff */
+	struct malloc_data50    u_md;
+
+	struct ixnode50         u_user_node;
+	struct Task             *u_task;
+	struct MsgPort          *u_sync_mp;     /* PA_SIGNAL message port */
+	struct timerequest      *u_time_req;
+	int                     *u_errno;
+	BPTR                    u_startup_cd;
+
+	int                     u_ringring;     /* used in sleep.c and usleep.c */
+
+	char                    ***u_environ;
+
+	/* used to handle AmigaOS signals. see SIGMSG  */
+	u_int                   u_lastrcvsig;
+	char                    u_sleep_sig;
+	char                    u_pipe_sig;
+
+	/* c-startup stuff */
+	jmp_buf50               u_jmp_buf;
+	char                    *u_argline;
+	u_int                   u_arglinelen;
+	int                     u_expand_cmd_line;
+
+	void                    *u_atexit;
+
+	char                    u_getenv_buf[255];
+
+	UBYTE                   u_is_ppc;       /* is this task a native ppc one ? */
+	void                    (*u_oexcept_code)();
+	APTR                    u_otrap_code;
+	APTR                    u_ouser;
+	struct Interrupt        u_itimerint;    /* 1 interrupt / task */
+
+	int                     p_pgrp;         /* process group */
+	struct session50        *u_session;     /* session pointer */
+
+	char                    *u_strtok_last; /* moved with 37.8 */
+
+	/* vfork() support */
+	struct ixlist50         p_zombies;      /* list of death messages */
+	int                     p_zombie_sig;   /* signal to set when a child died */
+	struct Process          *p_pptr;        /* parent */
+	struct Process          *p_opptr;       /* old parent (used in ptrace) */
+	struct Process          *p_cptr;        /* last recently created child */
+	struct Process          *p_osptr;       /* older sybling */
+	struct Process          *p_ysptr;       /* younger sybling */
+	void                    *p_vfork_msg;
+
+	void                    *u_segs;        /* execve stores the SegList here */
+	u_long                  u_start_pc;     /* start and end addresses */
+	u_long                  u_end_pc;       /* of the code hunk */
+	u_long                  u_oexcept_sigs;
+
+	/* stdio support comes here */
+	char                    u_tmpnam_bu[1024]; /* quite large.. */
+	u_long                  u_tmpcount;
+	struct glue50           u_sglue;
+	/* the 3 `standard' FILE pointers (!) are here */
+	void                    *u_sF[3];
+
+	/* vfork() support #2 */
+	void                    *u_save_sp;     /* when vfork'd, this is the `real' sp */
+	jmp_buf50               u_vfork_frame;  /* for the parent in vfork () */
+#ifdef __PPC__
+	u_int                   u_mini_stack[4000]; /* 16K stack while in vfork () */
+	u_char                  u_mini_stack_pad[15]; /* align pad area */
+#else
+	u_int                   u_mini_stack[1000]; /* 4K stack while in vfork () */
+#endif
+	/* stack watcher. When usp < u_red_zone && ix.ix_watch_stack -> SIGSEGV */
+	void                    *u_red_zone;
+
+	/* base relative support. This even works for pure programs ! */
+	u_int                   u_a4;
+
+	/* currently there's just 1, meaning don't trace me */
+	u_int                   u_trace_flags;
+
+	/* this is for getmntinfo() */
+	void                    *u_mntbuf;
+	int                     u_mntsize;
+	long                    u_bufsize;
+
+	/* this is for getmntinfo64() */
+	void                    *u_mntbuf64;
+	int                     u_mntsize64;
+	long                    u_bufsize64;
+
+	/* this is for SIGWINCH support. */
+	struct IOStdReq         *u_idev_req;
+	struct Window           *u_window;      /* the watched window */
+	struct Interrupt        u_idev_int;
+
+	/* for `ps' (or dump as it's called for now.. ) */
+	char                    *p_wmesg;
+
+	/* new support for `real' process groups, control ttys etc.. */
+	struct user             *p_pgrpnxt;
+	void                    *p_pgrpptr;
+	struct Process          *p_exec_proc;   /* to get back to struct Process */
+
+	/* to be able to switch memory lists on the fly, as required when vfork'd
+	   processes are supposed to allocate memory from their parents pool until
+	   they detach. */
+	struct malloc_data50    *u_mdp;
+
+	/* data needed for network support */
+	struct Library          *u_ixnetbase;
+	void                    *u_ixnet;
+	int                     *u_h_errno;
+
+	/* ptrace() and kern_sig.c:stopped_process_handler() interface.  */
+	void                    *u_regs;
+	void                    *u_fpregs;
+	int                     u_mask_state;
+
+	/* strftime() globals */
+	size_t                  u_gsize;
+	char                    *u_pt;
+
+	/* putenv() global */
+	int                     u_env_alloced;
+
+	/* rand() global */
+	u_long                  u_rand_next;
+
+	/* stuff for stackextend */
+#ifdef __MORPHOS__
+	void                    *u_68k_tc_splower;  /* original entries of task structure */
+	void                    *u_68k_tc_spupper;  /* to restore them at exit */
+	void                    *u_68k_org_lower;   /* original stackborders */
+	void                    *u_68k_org_upper;
+	void                    **u_68k_stk_limit;  /* pointer to limit variable */
+	unsigned long           u_68k_stk_argbt;    /* Maximum size of arguments */
+	void                    *u_68k_stk_used;    /* used stackframes */
+	void                    *u_68k_stk_spare;   /* spare stackframes */
+	unsigned long           u_68k_stk_current;  /* current stack size */
+	unsigned long           u_68k_stk_max;      /* maximum stack size so far */
+
+	void                    *u_ppc_tc_splower;  /* original entries of task structure */
+	void                    *u_ppc_tc_spupper;  /* to restore them at exit */
+	void                    *u_ppc_org_lower;   /* original stackborders */
+	void                    *u_ppc_org_upper;
+	void                    **u_ppc_stk_limit;  /* pointer to limit variable */
+	unsigned long           u_ppc_stk_argbt;    /* Maximum size of arguments */
+	void                    *u_ppc_stk_used;    /* used stackframes */
+	void                    *u_ppc_stk_spare;   /* spare stackframes */
+	unsigned long           u_ppc_stk_current;  /* current stack size */
+	unsigned long           u_ppc_stk_max;      /* maximum stack size so far */
+#else
+	void                    *u_tc_splower;  /* original entries of task structure */
+	void                    *u_tc_spupper;  /* to restore them at exit */
+	void                    *u_org_lower;   /* original stackborders */
+	void                    *u_org_upper;
+	void                    **u_stk_limit;  /* pointer to limit variable */
+	unsigned long           u_stk_argbt;    /* Maximum size of arguments */
+	void                    *u_stk_used;    /* used stackframes */
+	void                    *u_stk_spare;   /* spare stackframes */
+	unsigned long           u_stk_current;  /* current stack size */
+	unsigned long           u_stk_max;      /* maximum stack size so far */
+#endif
+	char u_root_directory[1024];            /* for chroot() */
+	short                   u_is_root;      /* current directory is root */
+
+	/* stuff for muFS support */
+	void                    *u_UserInfo;    /* private muUserInfo to use */
+	void                    *u_GroupInfo;   /* private muGroupInfo to use */
+	void                    *u_fileUserInfo;    /* private muUserInfo for database ops */
+	void                    *u_fileGroupInfo;   /* private muGroupInfo for database ops */
+	BOOL                    u_groupfileopen;    /* dummy for emulation */
+	BOOL                    u_passwdfileopen;   /* dummy for emulation */
+	struct passwd50         u_passwd;       /* static buffer to hold the data */
+	struct group50          u_group;        /* ditto */
+
+	void                    *u_grp_fp;      /* File pointer to the groups file */
+	int                     u_grp_stayopen; /* TRUE if group file should stay open */
+	char                    **u_members;    /* array of group members */
+	char                    *u_grp_line;    /* buffer for reading a line from the group file */
+
+	/* Support for ixnet functions */
+	void                    *u_serv_fp;     /* File pointer to services file */
+	char                    *u_serv_line;   /* buffer for reading a line from the services file */
+	struct servent50        u_serv;
+	char                    **u_serv_aliases;
+	int                     u_serv_stayopen;
+
+	void                    *u_proto_fp;    /* File pointer to protocol file */
+	char                    *u_proto_line;
+	struct protoent50       u_proto;
+	char                    **u_proto_aliases;
+	int                     u_proto_stayopen;
+
+	void                    *u_net_fp;      /* File pointer to network file */
+	char                    *u_net_line;
+	struct netent50         u_net;
+	char                    **u_net_aliases;
+	int                     u_net_stayopen;
+
+	int                     u_logname_valid;
+	char                    u_logname[12 + 1];
+	char                    u_logname_buf[12 + 1];
+
+	char                    u_ntoa_buf[18]; /* used by inet_ntoa */
+
+	/* resolv state structure */
+	void                    *u_res;
+	int                     *u_res_socket;
+
+	/* logfile handling */
+	int                     u_LogFile;      /* fd for log */
+	int                     u_LogStat;      /* status bits, set by openlog() */
+	char                    *u_LogTag;      /* string to tag the entry with */
+	int                     u_LogFacility;  /* default facility code */
+	int                     u_LogMask;      /* mask of priorities to be logged */
+
+	int                     u_setuid;       /* used for setuid() - have to remember
+						 * to log out */
+	/* mmap handling */
+	void                    *u_mmap;
+
+	struct MsgPort          *u_select_mp;   /* PA_SIGNAL message port */
+
+	/* strtod support */
+	void                    *u_freelist[16];
+	void                    *u_p5s;
+	void                    *u_result;
+	int                     u_result_k;
+
+	/* popen support */
+	pid50_t                *u_popen_pids;
+
+	/* uid / gid support */
+
+	void                    *u_pwd_fp;      /* File pointer to the passwd file */
+	int                     u_pwd_stayopen; /* TRUE if passwd file should stay open */
+	char                    *u_pwd_line;    /* buffer for reading a line from the passwd file */
+
+	char                    u_getpass_buf[128 + 1];
+
+	char                    u_crypt_buf[21];
+
+	uid50_t                 u_nextuid;
+	uid50_t                 u_nextgid;
+
+	uid50_t                 u_ruid;
+	uid50_t                 u_euid;
+	gid50_t                 u_rgid;
+	gid50_t                 u_egid;
+	int                     u_ngroups;
+	int                     u_grouplist[1];
+};
+#define STRC50    0x010
+#define SFREEA450 0x100
+
+#define SIG_DEF int __omask;
+#define SIG_LOCK() __omask = sigsetmask(~0)
+#define SIG_UNLOCK() sigsetmask(__omask)
+#else
+#define SIG_DEF
+#define SIG_LOCK() do {} while(0)
+#define SIG_UNLOCK() do {} while(0)
+#endif
+
+#define _MOS_DEBUG 0
+#if _MOS_DEBUG
+#define _D(__f, ...) NewRawDoFmt(__f, (APTR (*)(APTR, UBYTE)) RAWFMTFUNC_SERIAL, NULL, __VA_ARGS__)
+#else
+#define _D(__f, ...) do { } while(0)
+#endif
+
+/*
+ * Internal
+ */
+
+typedef struct {
+	struct MinNode key_node;
+	void (*key_dtor) (void *);
+	struct SignalSemaphore key_sem;
+	struct AVLNode *key_tree;
+} __internal_key_t;
+
+typedef struct {
+	struct AVLNode node;
+	ULONG owner; /* pid_t */
+	void *val;
+} __internal_key_node_t;
+
+/* Nice hack to avoid a constructor */
+static struct SignalSemaphore keysema = {
+	{NULL, NULL, NT_SIGNALSEM, 0, NULL}, 0, {(struct MinNode *) &keysema.ss_WaitQueue.mlh_Tail, NULL, (struct MinNode *) &keysema.ss_WaitQueue.mlh_Head}, {{NULL, NULL}, NULL}, NULL, -1
+};
+static struct MinList keylist = {
+	(struct MinNode *) &keylist.mlh_Tail, NULL, (struct MinNode *) &keylist.mlh_Head
+};
+#if USE_THREAD_SAFETYNET
+static struct MinList threadlist = {
+	(struct MinNode *) &threadlist.mlh_Tail, NULL, (struct MinNode *) &threadlist.mlh_Head
+};
+#endif
+
+typedef struct {
+	union {
+		struct SignalSemaphore	__sem;
+		char _priv[60]; /* __gthread_mutex_t */
+	} u;
+	int incond;
+} __internal_mutex_t;
+
+typedef struct {
+	union {
+		struct SignalSemaphore __sem;
+		char _priv[60];
+	} u1;
+	union {
+		struct MinList __waiters;
+		void *_priv[3];
+	} u2;
+} __internal_cond_t;
+
+struct taskmsg {
+	struct Message m;
+	struct MsgPort deathport;
+	struct MemList *ml;
+	struct MinNode node;
+#if USE_THREAD_SAFETYNET
+	struct Task *task;
+#endif
+#ifdef __ixemul
+	struct user50 *parent;
+	int sigmask;
+	struct Message syncmsg;
+#endif
+	void *(*func)(void *);
+	void *args;
+	char name[1];
+};
+
+/*
+ * if task is non-NULL must be called within Forbid()
+ */
+static struct taskmsg *GetThreadInternal(struct Task *task)
+{
+	struct taskmsg *msg = NULL;
+	NewGetTaskAttrs(task, &msg, sizeof(msg), TASKINFOTYPE_STARTUPMSG, TAG_DONE);
+	if(msg == NULL || msg->m.mn_Length != sizeof(*msg) ||
+	   msg->m.mn_Node.ln_Name != msg->name) {
+		msg = NULL;
+	}
+	return msg;
+}
+
+static inline void newlist(struct MinList *l)
+{
+	l->mlh_TailPred = (struct MinNode *) l;
+	l->mlh_Tail = (struct MinNode *) NULL;
+	l->mlh_Head = (struct MinNode *) &l->mlh_Tail;
+}
+static inline void addtail(struct MinList *l, struct MinNode *n)
+{
+	struct MinNode *opn;
+	opn = l->mlh_TailPred;
+	n->mln_Succ = (struct MinNode *) &l->mlh_Tail;
+	n->mln_Pred = opn;
+	opn->mln_Succ = n;
+	l->mlh_TailPred = n;
+}
+static inline void noderemove(struct MinNode *n)
+{
+	struct MinNode *pn, *sn;
+	pn = n->mln_Pred;
+	sn = n->mln_Succ;
+	pn->mln_Succ = sn;
+	sn->mln_Pred = pn;
+}
+
+static inline int SemaphoreIsInvalid(struct SignalSemaphore *sem)
+{
+	return sem->ss_Link.ln_Type != NT_SIGNALSEM || sem->ss_WaitQueue.mlh_Tail != NULL;
+}
+
+/* __gthr_morphos_enable */
+__ATTR_WEAK long __gthr_morphos_enable = 1;
+
+int __gthr_morphos_active_p (void)
+{
+	return __gthr_morphos_enable;
+}
+
+/* __gthr_morphos_once */
+int __gthr_morphos_once (__gthread_once_t *__once, void (*__func) (void))
+{
+	SIG_DEF
+	_D("<%s/%s():%lu> __gthread_once_t == 0x%p, __func == 0x%p\n", __FILE__, __FUNCTION__, __LINE__, __once, __func);
+
+	if(__once == NULL || __func == NULL) {
+		_D("<%s/%s():%lu> == EINVAL\n", __FILE__, __FUNCTION__, __LINE__);
+		return EINVAL;
+	}
+
+	_D("<%s/%s():%lu> __once->done = %d, __once->busy = %d\n", __FILE__, __FUNCTION__, __LINE__, __once->done, __once->busy);
+
+	if(__once->done)
+		return 0;
+
+	while(ATOMIC_STORE((LONG *) &__once->busy, 1)) {
+#ifdef __ixemul
+		SIG_LOCK();
+		usleep(20000); /* 50 times per second */
+		SIG_UNLOCK();
+#else
+		void (*oldhandler)(int) = signal(SIGINT, (void (*)(int)) SIG_IGN);
+		usleep(20000); /* 50 times per second */
+		signal(SIGINT, oldhandler);
+#endif
+	}
+
+	if(!__once->done) {
+		_D("<%s/%s():%lu> -> __func()\n", __FILE__, __FUNCTION__, __LINE__);
+		(*__func) ();
+		_D("<%s/%s():%lu> __once->done -> TRUE\n", __FILE__, __FUNCTION__, __LINE__);
+		__once->done = 1;
+	}
+	(void)ATOMIC_STORE((LONG *) &__once->busy, 0);
+
+	_D("<%s/%s():%lu> == 0\n", __FILE__, __FUNCTION__, __LINE__);
+	return 0;
+}
+
+/* __gthr_morphos_once_unlock */
+void __gthr_morphos_once_unlock (__gthread_once_t *__once)
+{
+	(void)ATOMIC_STORE((LONG *) &__once->busy, 0);
+}
+
+/* __gthr_morphos_key_create */
+int __gthr_morphos_key_create (__gthread_key_t *__key, void (*__func) (void *))
+{
+	__internal_key_t *key_internal;
+	SIG_DEF
+
+	_D("<%s/%s():%lu> __gthread_key_t == 0x%p, __func == 0x%p\n", __FILE__, __FUNCTION__, __LINE__, __key, __func);
+
+	if(__key == NULL) {
+		_D("<%s/%s():%lu> == EINVAL\n", __FILE__, __FUNCTION__, __LINE__);
+		return EINVAL;
+	}
+
+	if (LIB_MINVER((struct Library *) EXEC_BASE_NAME, 51, 46)) {
+		ULONG index;
+		SIG_LOCK();
+		index = TLSAlloc(__func ? TLSTAG_DESTRUCTOR : TAG_IGNORE, (IPTR) __func, TAG_DONE);
+		SIG_UNLOCK();
+		if (index == TLS_INVALID_INDEX)
+			return ENOMEM;
+		*__key = (__gthread_key_t) index;
+		return 0;
+	}
+
+	key_internal = (__internal_key_t *) malloc(sizeof(*key_internal));
+	if(key_internal == NULL) {
+		_D("<%s/%s():%lu> == ENOMEM\n", __FILE__, __FUNCTION__, __LINE__);
+		return ENOMEM;
+	}
+
+	/* Setup key */
+	key_internal->key_dtor = __func;
+	key_internal->key_tree = 0;
+	memset(&key_internal->key_sem, 0, sizeof(key_internal->key_sem));
+	SIG_LOCK();
+	InitSemaphore(&key_internal->key_sem);
+
+	ObtainSemaphore(&keysema);
+	addtail(&keylist, &key_internal->key_node);
+	ReleaseSemaphore(&keysema);
+
+	_D("<%s/%s():%lu> key_internal[key_dtor == 0x%p, &key_tree == 0x%p, key_sem == 0x%p]\n", __FILE__, __FUNCTION__, __LINE__, key_internal->key_dtor, &key_internal->key_tree, &key_internal->key_sem);
+
+	*__key = (__gthread_key_t) key_internal;
+
+	_D("<%s/%s():%lu> == 0\n", __FILE__, __FUNCTION__, __LINE__);
+
+	SIG_UNLOCK();
+	return 0;
+}
+
+/* __gthr_morphos_key_delete */
+int __gthr_morphos_key_delete (__gthread_key_t __key)
+{
+	__internal_key_t *key_internal = (__internal_key_t *) __key;
+	__internal_key_node_t *key_node, *next_node;
+#if !USE_THREAD_ONLY_SETSPECIFIC
+	ULONG __pid = 0;
+	int is_thread;
+#endif
+	SIG_DEF
+
+	_D("<%s/%s():%lu> __gthread_key_t == 0x%p\n", __FILE__, __FUNCTION__, __LINE__, __key);
+
+	if (LIB_MINVER((struct Library *) EXEC_BASE_NAME, 51, 46)) {
+		LONG rc;
+		SIG_LOCK();
+		rc = TLSFree((ULONG) __key);
+		SIG_UNLOCK();
+		return rc ? 0 : EINVAL;
+	}
+
+	if(key_internal == NULL) {
+		_D("<%s/%s():%lu> == EINVAL\n", __FILE__, __FUNCTION__, __LINE__);
+		return EINVAL;
+	}
+
+	SIG_LOCK();
+
+#if !USE_THREAD_ONLY_SETSPECIFIC
+	is_thread = GetThreadInternal(NULL) != NULL;
+	NewGetTaskAttrsA(NULL, &__pid, sizeof(__pid), TASKINFOTYPE_PID, NULL);
+#endif
+
+	ObtainSemaphore(&keysema);
+	noderemove(&key_internal->key_node);
+	ReleaseSemaphore(&keysema);
+
+	/* Free all the nodes - note that it is up to the application to make sure
+	   there no are races accessing the key at this stage. */
+
+	for(key_node = (__internal_key_node_t *) AVL_FindFirstNode(key_internal->key_tree);
+	    key_node;
+	    key_node = next_node) {
+		next_node = (__internal_key_node_t *) AVL_FindNextNodeByAddress(&key_node->node);
+
+#if !USE_THREAD_ONLY_SETSPECIFIC
+		/* Call the destructor if the delete is called by the non-thread
+		   owner of this specific node. */
+		if(!is_thread && key_internal->key_dtor && key_node->val && key_node->owner == __pid) {
+			void *oldvalue = key_node->val;
+			key_node->val = NULL;
+			key_internal->key_dtor(oldvalue);
+		}
+#endif
+		/* free resources associated with the node */
+		free(key_node);
+	}
+
+	free(key_internal);
+
+	_D("<%s/%s():%lu> == 0\n", __FILE__, __FUNCTION__, __LINE__);
+	SIG_UNLOCK();
+
+	return 0;
+}
+
+static LONG ownernodecomparfunc(struct AVLNode *avlnode1, struct AVLNode *avlnode2)
+{
+	const __internal_key_node_t *key_node1 = (const __internal_key_node_t *) avlnode1;
+	const __internal_key_node_t *key_node2 = (const __internal_key_node_t *) avlnode2;
+	return (LONG) ((IPTR) key_node1->owner - (IPTR) key_node2->owner);
+}
+static LONG ownerkeycomparfunc(struct AVLNode *avlnode1, AVLKey avlkey)
+{
+	const __internal_key_node_t *key_node1 = (const __internal_key_node_t *) avlnode1;
+	return (LONG) ((IPTR) key_node1->owner - (IPTR) avlkey);
+}
+
+static __internal_key_node_t *__gthr_morphos_find_specific_node(__internal_key_t *key_internal, ULONG pid)
+{
+	__internal_key_node_t *key_node;
+	key_node = (__internal_key_node_t *) AVL_FindNode(key_internal->key_tree, (AVLKey) pid, (AVLKEYCOMP) ownerkeycomparfunc);
+	_D("<%s/%s():%lu> == 0x%p\n", __FILE__, __FUNCTION__, __LINE__, key_node);
+	return key_node;
+}
+
+#define GTHREAD_DESTRUCTOR_ITERATIONS 4
+
+static void thread_cleanup(void)
+{
+	ULONG __pid = 0;
+	int foundkey, i;
+	SIG_DEF
+
+	SIG_LOCK();
+
+	NewGetTaskAttrsA(NULL, &__pid, sizeof(__pid), TASKINFOTYPE_PID, NULL);
+
+	/* Destroy all non-NULL key values for this thread.
+	   Since the destructors can set the keys themselves, we have to
+	   do multiple iterations. */
+
+	for(foundkey = 1, i = 0; foundkey && i < GTHREAD_DESTRUCTOR_ITERATIONS; i++) {
+		__internal_key_t *key_internal;
+		foundkey = 0;
+		ObtainSemaphore(&keysema);
+		for(key_internal = (__internal_key_t *) keylist.mlh_Head;
+		    key_internal->key_node.mln_Succ;
+		    key_internal = (__internal_key_t *) key_internal->key_node.mln_Succ) {
+			__internal_key_node_t *key_node;
+
+			ObtainSemaphore(&key_internal->key_sem);
+			key_node = __gthr_morphos_find_specific_node(key_internal, __pid);
+			if(key_node) {
+				if(key_internal->key_dtor && key_node->val) {
+					void *oldvalue = key_node->val;
+					key_node->val = NULL;
+					key_internal->key_dtor(oldvalue);
+					foundkey = 1;
+				}
+
+				/* unlink the node from the tree */
+				AVL_RemNodeByAddress(&key_internal->key_tree, &key_node->node);
+				/* free resources associated with the node */
+				free(key_node);
+			}
+
+			/* You might think that it would make sense to try to purge
+			   keys that become "empty" here. However, this would break
+			   calls to __gthread_key_delete. So don't do it. */
+			ReleaseSemaphore(&key_internal->key_sem);
+		}
+		ReleaseSemaphore(&keysema);
+	}
+
+	SIG_UNLOCK();
+}
+
+/* __gthr_morphos_getspecific */
+void *__gthr_morphos_getspecific (__gthread_key_t __key)
+{
+	__internal_key_t *key_internal = (__internal_key_t *) __key;
+	__internal_key_node_t *key_node;
+	ULONG __pid = 0;
+	SIG_DEF
+
+	_D("<%s/%s():%lu> __gthread_key_t == 0x%p\n", __FILE__, __FUNCTION__, __LINE__, __key);
+
+	if (LIB_MINVER((struct Library *) EXEC_BASE_NAME, 51, 46)) {
+		/* NOTE: TLSGetValue doesn't require signal locking */
+		return (void *) TLSGetValue((ULONG) __key);
+	}
+
+	if(key_internal == NULL) {
+		_D("<%s/%s():%lu> == NULL\n", __FILE__, __FUNCTION__, __LINE__);
+		return NULL;
+	}
+
+	SIG_LOCK();
+
+	NewGetTaskAttrsA(NULL, &__pid, sizeof(__pid), TASKINFOTYPE_PID, NULL);
+
+	ObtainSemaphoreShared(&key_internal->key_sem);
+	key_node = __gthr_morphos_find_specific_node(key_internal, __pid);
+	ReleaseSemaphore(&key_internal->key_sem);
+
+	_D("<%s/%s():%lu> == 0x%p\n", __FILE__, __FUNCTION__, __LINE__, key_node ? key_node->val : NULL);
+
+	SIG_UNLOCK();
+
+	return key_node ? CONST_CAST(void *, key_node->val) : NULL;
+}
+
+/* __gthr_morphos_setspecific */
+int __gthr_morphos_setspecific (__gthread_key_t __key, const void *__v)
+{
+	__internal_key_t *key_internal = (__internal_key_t *) __key;
+	__internal_key_node_t *key_node;
+	ULONG __pid = 0;
+	SIG_DEF
+
+	_D("<%s/%s():%lu> __gthread_key_t == 0x%p, __v == 0x%p\n", __FILE__, __FUNCTION__, __LINE__, __key, __v);
+
+	if (LIB_MINVER((struct Library *) EXEC_BASE_NAME, 51, 46)) {
+		int rc;
+		SIG_LOCK();
+		rc = TLSSetValue((ULONG) __key, (APTR) __v) ? 0 : ENOMEM;
+		SIG_UNLOCK();
+		return rc;
+	}
+
+	/* Illegal for keys already destroyed by __gthread_key_delete */
+	if(key_internal == NULL) {
+		_D("<%s/%s():%lu> == EINVAL\n", __FILE__, __FUNCTION__, __LINE__);
+		return EINVAL;
+	}
+
+	SIG_LOCK();
+
+#if USE_THREAD_ONLY_SETSPECIFIC
+	if(GetThreadInternal(NULL) == NULL) {
+		/* Tried to setspecific for not a thread. */
+		_D("<%s/%s():%lu> == EINVAL\n", __FILE__, __FUNCTION__, __LINE__);
+		SIG_UNLOCK();
+		return EINVAL;
+	}
+#endif
+
+	NewGetTaskAttrsA(NULL, &__pid, sizeof(__pid), TASKINFOTYPE_PID, NULL);
+
+	ObtainSemaphore(&key_internal->key_sem);
+
+	key_node = __gthr_morphos_find_specific_node(key_internal, __pid);
+
+	if(key_node != NULL) {
+		/* Update existing node */
+		_D("<%s/%s():%lu> key_node->val 0x%p -> 0x%p\n", __FILE__, __FUNCTION__, __LINE__, key_node->val, __v);
+		key_node->val = (void *) __v;
+
+		ReleaseSemaphore(&key_internal->key_sem);
+
+		_D("<%s/%s():%lu> == 0\n", __FILE__, __FUNCTION__, __LINE__);
+
+		SIG_UNLOCK();
+		return 0;
+	}
+
+	/* Create a new node */
+	key_node = (__internal_key_node_t *) malloc(sizeof(*key_node));
+
+	if(key_node == NULL) {
+		ReleaseSemaphore(&key_internal->key_sem);
+
+		_D("<%s/%s():%lu> == ENOMEM\n", __FILE__, __FUNCTION__, __LINE__);
+
+		SIG_UNLOCK();
+		return ENOMEM;
+	}
+
+	key_node->owner = __pid;
+	key_node->val = (void *) __v;
+
+	_D("<%s/%s():%lu> key_node->val == 0x%p\n", __FILE__, __FUNCTION__, __LINE__, key_node->val);
+	AVL_AddNode(&key_internal->key_tree, &key_node->node, (AVLNODECOMP) ownernodecomparfunc);
+
+	ReleaseSemaphore(&key_internal->key_sem);
+
+	_D("<%s/%s():%lu> == 0\n", __FILE__, __FUNCTION__, __LINE__);
+
+	SIG_UNLOCK();
+	return 0;
+}
+
+/* __gthr_morphos_mutex_init_function */
+void __gthr_morphos_mutex_init_function (__gthread_mutex_t *_gthr_mutex)
+{
+	__internal_mutex_t *__mutex = (__internal_mutex_t *) _gthr_mutex;
+	SIG_DEF
+
+	_D("<%s/%s():%lu> __gthread_mutex_t == 0x%p\n", __FILE__, __FUNCTION__, __LINE__, __mutex);
+
+	if(__mutex == NULL) {
+		return;
+	}
+
+	SIG_LOCK();
+	InitSemaphore(&__mutex->u.__sem);
+	SIG_UNLOCK();
+
+	__mutex->incond = 0;
+}
+
+/* __gthr_morphos_mutex_destroy */
+int __gthr_morphos_mutex_destroy (__gthread_mutex_t *_gthr_mutex)
+{
+	__internal_mutex_t *__mutex = (__internal_mutex_t *) _gthr_mutex;
+	SIG_DEF
+
+	_D("<%s/%s():%lu> __gthread_mutex_t == 0x%p\n", __FILE__, __FUNCTION__, __LINE__, __mutex);
+
+	if(__mutex == NULL) {
+		_D("<%s/%s():%lu> == EINVAL\n", __FILE__, __FUNCTION__, __LINE__);
+		return EINVAL;
+	}
+
+	if(SemaphoreIsInvalid(&__mutex->u.__sem)) {
+		/* static mutex not yet initialized, so do nothing */
+		return 0;
+	}
+
+	SIG_LOCK();
+
+	if(!AttemptSemaphore(&__mutex->u.__sem)) {
+		_D("<%s/%s():%lu> == EBUSY\n", __FILE__, __FUNCTION__, __LINE__);
+
+		SIG_UNLOCK();
+		return EBUSY;
+	}
+
+	if(__mutex->incond) {
+		_D("<%s/%s():%lu> == EBUSY\n", __FILE__, __FUNCTION__, __LINE__);
+		ReleaseSemaphore(&__mutex->u.__sem);
+
+		SIG_UNLOCK();
+		return EBUSY;
+        }
+
+	memset(&__mutex->u.__sem, 0, sizeof(__mutex->u.__sem));
+	__gthr_morphos_mutex_init_function(_gthr_mutex);
+
+	_D("<%s/%s():%lu> == 0\n", __FILE__, __FUNCTION__, __LINE__);
+
+	SIG_UNLOCK();
+	return 0;
+}
+
+static int __gthr_morphos_mutex_lock_generic (__gthread_mutex_t *_gthr_mutex, int recursive)
+{
+	__internal_mutex_t *__mutex = (__internal_mutex_t *) _gthr_mutex;
+	SIG_DEF
+
+	_D("<%s/%s():%lu> __gthread_mutex_t == 0x%p\n", __FILE__, __FUNCTION__, __LINE__, __mutex);
+
+	if(__mutex == NULL) {
+		_D("<%s/%s():%lu> == EINVAL\n", __FILE__, __FUNCTION__, __LINE__);
+		return EINVAL;
+
+	}
+
+	SIG_LOCK();
+
+	/* initialize static mutex */
+	Forbid();
+	if(SemaphoreIsInvalid(&__mutex->u.__sem))
+		__gthr_morphos_mutex_init_function(_gthr_mutex);
+	Permit();
+
+	ObtainSemaphore(&__mutex->u.__sem);
+
+	if(!recursive && __mutex->u.__sem.ss_NestCount > 1) {
+		ReleaseSemaphore(&__mutex->u.__sem);
+		_D("<%s/%s():%lu> == EDEADLK\n", __FILE__, __FUNCTION__, __LINE__);
+		SIG_UNLOCK();
+		return EDEADLK;
+	}
+
+	_D("<%s/%s():%lu> == 0\n", __FILE__, __FUNCTION__, __LINE__);
+
+	SIG_UNLOCK();
+	return 0;
+}
+
+/* __gthr_morphos_mutex_lock */
+int __gthr_morphos_mutex_lock (__gthread_mutex_t *_gthr_mutex)
+{
+	return __gthr_morphos_mutex_lock_generic (_gthr_mutex, 0);
+}
+
+static int __gthr_morphos_mutex_trylock_generic (__gthread_mutex_t *_gthr_mutex, int recursive)
+{
+	__internal_mutex_t *__mutex = (__internal_mutex_t *) _gthr_mutex;
+	LONG rc;
+	SIG_DEF
+
+	_D("<%s/%s():%lu> __gthread_mutex_t == 0x%p\n", __FILE__, __FUNCTION__, __LINE__, __mutex);
+
+	if(__mutex == NULL) {
+		_D("<%s/%s():%lu> == EINVAL\n", __FILE__, __FUNCTION__, __LINE__);
+		return EINVAL;
+	}
+
+	SIG_LOCK();
+
+	/* initialize static mutex */
+	Forbid();
+	if(SemaphoreIsInvalid(&__mutex->u.__sem))
+		__gthr_morphos_mutex_init_function(_gthr_mutex);
+	Permit();
+
+	rc = AttemptSemaphore(&__mutex->u.__sem);
+
+	if(rc) {
+		if(!recursive && __mutex->u.__sem.ss_NestCount > 1) {
+			ReleaseSemaphore(&__mutex->u.__sem);
+			_D("<%s/%s():%lu> == EDEADLK\n", __FILE__, __FUNCTION__, __LINE__);
+			SIG_UNLOCK();
+			return EDEADLK;
+		}
+	} else {
+		_D("<%s/%s():%lu> == EBUSY\n", __FILE__, __FUNCTION__, __LINE__);
+		SIG_UNLOCK();
+		return EBUSY;
+	}
+
+	_D("<%s/%s():%lu> == 0\n", __FILE__, __FUNCTION__, __LINE__);
+	SIG_UNLOCK();
+	return 0;
+}
+
+/* __gthr_morphos_mutex_trylock */
+int __gthr_morphos_mutex_trylock (__gthread_mutex_t *__mutex)
+{
+	return __gthr_morphos_mutex_trylock_generic (__mutex, 0);
+}
+
+/* __gthr_morphos_mutex_unlock */
+int __gthr_morphos_mutex_unlock (__gthread_mutex_t *_gthr_mutex)
+{
+	__internal_mutex_t *__mutex = (__internal_mutex_t *) _gthr_mutex;
+	SIG_DEF
+
+	_D("<%s/%s():%lu> __gthread_mutex_t == 0x%p\n", __FILE__, __FUNCTION__, __LINE__, __mutex);
+
+	if(__mutex == NULL) {
+		_D("<%s/%s():%lu> == EINVAL\n", __FILE__, __FUNCTION__, __LINE__);
+		return EINVAL;
+	}
+
+	SIG_LOCK();
+
+	/* initialize static mutex */
+	Forbid();
+	if(SemaphoreIsInvalid(&__mutex->u.__sem))
+		__gthr_morphos_mutex_init_function(_gthr_mutex);
+	Permit();
+
+	if(__mutex->u.__sem.ss_Owner != FindTask(NULL)) {
+		_D("<%s/%s():%lu> == EPERM\n", __FILE__, __FUNCTION__, __LINE__);
+		SIG_UNLOCK();
+		return EPERM;
+	}
+
+	ReleaseSemaphore(&__mutex->u.__sem);
+
+	_D("<%s/%s():%lu> == 0\n", __FILE__, __FUNCTION__, __LINE__);
+
+	SIG_UNLOCK();
+	return 0;
+}
+
+
+static inline void UNIXTIME_TO_AMIGATIME(const struct TimeVal *from, struct TimeVal *to)
+{
+	const ULONG unix_to_amiga = (8 * 365 + 2) * 24 * 60 * 60;
+
+	if(from->tv_secs >= unix_to_amiga) {
+		to->tv_secs = from->tv_secs - unix_to_amiga;
+		to->tv_micro = from->tv_micro;
+	} else {
+		to->tv_secs = 0;
+		to->tv_micro = 0;
+	}
+}
+
+static int __gthr_morphos_mutex_timedlock_generic (__gthread_mutex_t *_gthr_mutex,
+                                                   const __gthread_time_t *abs_timeout,
+                                                   int recursive)
+{
+	__internal_mutex_t *__mutex = (__internal_mutex_t *) _gthr_mutex;
+	struct MsgPort mp;
+	struct SemaphoreMessage bidmsg;
+	struct timerequest tr;
+	struct Message *msg;
+	SIG_DEF
+
+	_D("<%s/%s():%lu> __gthread_mutex_t == 0x%p\n", __FILE__, __FUNCTION__, __LINE__, __mutex);
+
+	if(__mutex == NULL) {
+		_D("<%s/%s():%lu> == EINVAL\n", __FILE__, __FUNCTION__, __LINE__);
+		return EINVAL;
+	}
+
+	SIG_LOCK();
+
+	/* initialize static mutex */
+	Forbid();
+	if(SemaphoreIsInvalid(&__mutex->u.__sem))
+		__gthr_morphos_mutex_init_function(_gthr_mutex);
+	Permit();
+
+	if(AttemptSemaphore(&__mutex->u.__sem)) {
+		if(!recursive && __mutex->u.__sem.ss_NestCount > 1) {
+			ReleaseSemaphore(&__mutex->u.__sem);
+			SIG_UNLOCK();
+			return EDEADLK;
+		}
+		SIG_UNLOCK();
+		return 0;
+	}
+
+	if(abs_timeout->tv_sec < 0 || abs_timeout->tv_nsec < 0 || abs_timeout->tv_nsec > 999999999) {
+		_D("<%s/%s():%lu> == EINVAL\n", __FILE__, __FUNCTION__, __LINE__);
+
+		SIG_UNLOCK();
+		return EINVAL;
+	}
+
+	mp.mp_Node.ln_Type = NT_MSGPORT;
+	mp.mp_Flags = PA_SIGNAL;
+	mp.mp_SigBit = AllocSignal(-1);
+	if((BYTE)mp.mp_SigBit == -1) {
+		mp.mp_SigBit = SIGBREAKB_CTRL_F;
+		SetSignal(1UL << mp.mp_SigBit, 0);
+	}
+	mp.mp_SigTask = FindTask(NULL);
+	newlist((struct MinList *) &mp.mp_MsgList);
+
+	tr.tr_node.io_Message.mn_Node.ln_Type = NT_REPLYMSG;
+	tr.tr_node.io_Message.mn_ReplyPort = &mp;
+	tr.tr_node.io_Message.mn_Length = sizeof(tr);
+
+	if(OpenDevice(TIMERNAME, UNIT_WAITUTC, (APTR) &tr, 0) != 0) {
+		if(mp.mp_SigBit != SIGBREAKB_CTRL_F)
+			FreeSignal(mp.mp_SigBit);
+
+		SIG_UNLOCK();
+		return ENOTSUP;
+	}
+
+	bidmsg.ssm_Message.mn_Node.ln_Type = NT_MESSAGE;
+	bidmsg.ssm_Message.mn_Node.ln_Name = (APTR) 0; /* exclusive lock */
+	bidmsg.ssm_Message.mn_ReplyPort = &mp;
+	bidmsg.ssm_Message.mn_Length = sizeof(bidmsg);
+	Procure(&__mutex->u.__sem, &bidmsg);
+
+	tr.tr_node.io_Command = TR_ADDREQUEST;
+	tr.tr_time.tv_secs  = abs_timeout->tv_sec;
+	tr.tr_time.tv_micro = abs_timeout->tv_nsec / 1000;
+	UNIXTIME_TO_AMIGATIME(&tr.tr_time, &tr.tr_time);
+	SendIO((APTR) &tr);
+
+	msg = WaitPort(&mp);
+
+	if(!CheckIO((APTR) &tr)) {
+		AbortIO((APTR) &tr);
+		WaitIO((APTR) &tr);
+	}
+
+	CloseDevice((APTR) &tr);
+
+	if(msg == &tr.tr_node.io_Message)
+		Vacate(&__mutex->u.__sem, &bidmsg);
+
+	if((BYTE)mp.mp_SigBit != SIGBREAKB_CTRL_F)
+		FreeSignal(mp.mp_SigBit);
+
+	SIG_UNLOCK();
+
+	return msg == &tr.tr_node.io_Message ? ETIMEDOUT : 0;
+}
+
+/* __gthr_morphos_mutex_timedlock */
+int __gthr_morphos_mutex_timedlock (__gthread_mutex_t *__mutex,
+                                    const __gthread_time_t *__abs_timeout)
+{
+	return __gthr_morphos_mutex_timedlock_generic (__mutex, __abs_timeout, 0);
+}
+
+/* __gthr_morphos_recursive_mutex_init_function */
+void __gthr_morphos_recursive_mutex_init_function (__gthread_recursive_mutex_t *__mutex)
+{
+	__gthr_morphos_mutex_init_function (__mutex);
+}
+
+/* __gthr_morphos_recursive_mutex_lock */
+int __gthr_morphos_recursive_mutex_lock (__gthread_recursive_mutex_t *__mutex)
+{
+	return __gthr_morphos_mutex_lock_generic (__mutex, 1);
+}
+
+/* __gthr_morphos_recursive_mutex_trylock */
+int __gthr_morphos_recursive_mutex_trylock (__gthread_recursive_mutex_t *__mutex)
+{
+	return __gthr_morphos_mutex_trylock_generic (__mutex, 1);
+}
+
+/* __gthr_morphos_recursive_mutex_unlock */
+int __gthr_morphos_recursive_mutex_unlock (__gthread_recursive_mutex_t *__mutex)
+{
+	return __gthr_morphos_mutex_unlock (__mutex);
+}
+
+/* __gthr_morphos_recursive_mutex_timedlock */
+int __gthr_morphos_recursive_mutex_timedlock (__gthread_recursive_mutex_t *__mutex,
+                                              const __gthread_time_t *__abs_time)
+{
+	return __gthr_morphos_mutex_timedlock_generic (__mutex, __abs_time, 1);
+}
+
+/* Thread */
+
+#ifdef __ixemul
+
+static void safe_ix_user_release_sockets(struct user50 *u)
+{
+	if (LIB_MINVER((struct Library *)u->u_ixbase, 50, 18))
+	{
+		ix_user_release_sockets((struct user *) u);
+	}
+	else
+	{
+		int i;
+		for(i = 0; i < NOFILE50; i++)
+		{
+			if(u->u_ofile[i] && u->u_ofile[i]->f_type == DTYPE_SOCKET50)
+				u->u_ofile[i]->f_socket_id = ix_release_socket(i);
+		}
+	}
+}
+
+static int safe_ix_user_clone_parent(struct user50 *pu, struct user50 *mu)
+{
+	int a4_size;
+	int fd;
+	SIG_DEF
+
+	if (LIB_MINVER((struct Library *)mu->u_ixbase, 50, 18))
+	{
+		return ix_user_clone_parent((struct user *) pu, (struct user *) mu);
+	}
+
+	a4_size = pu->u_a4_pointers_size * 4;
+
+	mu->u_is_ppc = pu->u_is_ppc;
+
+	/* don't mess with process pointers for now */
+	mu->p_osptr = 0;
+	mu->p_ysptr = 0;
+	mu->p_pptr = 0;
+
+	SIG_LOCK();
+	Forbid();
+
+	/* inherit the session of our parent */
+	mu->u_session = pu->u_session;
+	if(mu->u_session)
+		mu->u_session->s_count++; /* and increase use count */
+
+	/* inherit the process group of our parent */
+	mu->p_pgrp = pu->p_pgrp;
+
+	/* inherit the uid/gid information from parent */
+	mu->u_ruid = pu->u_ruid;
+	mu->u_euid = pu->u_euid;
+	mu->u_rgid = pu->u_rgid;
+	mu->u_egid = pu->u_egid;
+
+	if((mu->u_ngroups = pu->u_ngroups))
+		bcopy((char *)pu->u_grouplist, (char *)mu->u_grouplist, pu->u_ngroups * sizeof(int));
+
+	if((mu->u_logname_valid = pu->u_logname_valid))
+		strcpy((char *)mu->u_logname, (char *)pu->u_logname);
+
+	/*shmfork(pu, mu);*/
+
+	/* borrow the variables of the parent */
+	mu->u_environ = pu->u_environ;
+	mu->u_errno = pu->u_errno;
+
+	/* tell malloc to use the parents malloc lists */
+	mu->u_mdp = pu->u_mdp;
+
+	/* and inherit several other things as well, upto not including u_md */
+	bcopy ((void *)&pu->u_a4_pointers_size, (void *)&mu->u_a4_pointers_size,
+               offsetof (struct user50, u_md) - offsetof (struct user50, u_a4_pointers_size));
+	bcopy ((char *)pu - a4_size, (char *)mu - a4_size, a4_size);
+
+	/* some things have been copied that should be reset */
+	mu->p_flag &= ~(SFREEA450 | STRC50);
+	mu->p_xstat = 0;
+	bzero ((void *)&mu->u_ru, sizeof (struct rusage50));
+	bzero ((void *)&mu->u_prof, sizeof (struct uprof50));
+	mu->u_prof_last_pc = 0;
+	bzero ((void *)&mu->u_cru, sizeof (struct rusage50));
+	bzero ((void *)&mu->u_timer[0], sizeof (struct itimerval50)); /* just the REAL timer! */
+	gettimeofday ((struct timeval *) & mu->u_start, 0);
+
+	/* and adjust the open count of each of the copied filedescriptors */
+	for(fd = 0; fd < NOFILE50; fd++)
+	{
+		if(!mu->u_ofile[fd])
+			continue;
+
+		/* obtain (and create a new fd) for INET sockets */
+		if(mu->u_ofile[fd]->f_type == DTYPE_SOCKET50)
+		{
+			int newfd, fd2;
+
+			/* Was this socket released? */
+			if(!mu->u_ofile[fd]->f_socket_id)
+				continue;
+
+			/* Yes, it was. So we now obtain a new socket from the underlying TCP/IP stack */
+			newfd = ix_obtain_socket(mu->u_ofile[fd]->f_socket_id,
+				mu->u_ofile[fd]->f_socket_domain,
+				mu->u_ofile[fd]->f_socket_type,
+				mu->u_ofile[fd]->f_socket_protocol);
+
+			mu->u_ofile[fd]->f_socket_id = 0;
+
+			if(newfd == -1)
+				continue;
+
+			/* Move the newly created fd to the old one.
+
+			   Tricky bit: we have to remember that for dupped sockets all file descriptors
+			   point to the same file structure: obtaining one released file descriptor will
+			   obtain them all. So we have to scan for file descriptors that point to the
+			   same file structure for which we just obtained the socket and copy the new
+			   file structure into the dupped file descriptors.
+
+			   Note that the newly created file structure has the field f_socket_id set to 0,
+			   so we won't come here again because of the if-statement above that tests whether
+			   the socket was released. */
+
+			/* scan the file descriptors */
+			for(fd2 = fd + 1; fd2 < NOFILE50; fd2++)
+			{
+				/* do they point to the same file structure? */
+				if(mu->u_ofile[fd] == mu->u_ofile[fd2])
+				{
+					/* in that case copy the newly obtained socket into this file descriptor
+					   and increase the open count */
+					mu->u_ofile[fd2] = mu->u_ofile[newfd];
+					mu->u_ofile[newfd]->f_count++;
+				}
+			}
+			/* and finally do the same for fd */
+			mu->u_ofile[fd] = mu->u_ofile[newfd];
+			mu->u_ofile[newfd] = 0;
+		}
+		else
+			mu->u_ofile[fd]->f_count++;
+	}
+
+	/* also copy u_segs, after all, the child will run initially in the
+	   same SegList as the parent. */
+	mu->u_segs = pu->u_segs;
+	mu->u_start_pc = pu->u_start_pc;
+	mu->u_end_pc = pu->u_end_pc;
+
+	mu->u_is_root = pu->u_is_root;
+	mu->u_a4 = pu->u_a4;
+
+	Permit();
+	SIG_UNLOCK();
+
+	return 0;
+}
+
+static void safe_ix_user_cleanup(struct user50 *mu)
+{
+	int i;
+
+	if (LIB_MINVER((struct Library *)mu->u_ixbase, 50, 18))
+	{
+		ix_user_cleanup((struct user *) mu);
+		return;
+	}
+
+	for(i = 0; i < NOFILE50; i++)
+		if(mu->u_ofile[i])
+			close(i);
+}
+#endif
+
+static void entryfunc(struct taskmsg *msg)
+{
+	struct Process *self = (struct Process *) FindTask(NULL);
+#ifdef __ixemul
+	struct MsgPort fakemp;
+	struct WBStartup wbmsg;
+	struct Library *ixbase;
+	struct user50 *mu;
+#endif
+	addtail((struct MinList *) &self->pr_Task.tc_MemEntry, (struct MinNode *) &msg->ml->ml_Node);
+
+#ifdef __ixemul
+	/* pr_CLI is NULL since we are a process, so ix_open will expect a wb message. Fake one. */
+	fakemp.mp_Node.ln_Type = NT_MSGPORT;
+	fakemp.mp_Flags = PA_IGNORE;
+	newlist((struct MinList *) &fakemp.mp_MsgList);
+	wbmsg.sm_Message.mn_Node.ln_Type = NT_MESSAGE;
+	wbmsg.sm_Message.mn_ReplyPort = &fakemp;
+	wbmsg.sm_Message.mn_Length = sizeof(wbmsg);
+	wbmsg.sm_Process = &self->pr_MsgPort;
+	wbmsg.sm_NumArgs = 0;
+	wbmsg.sm_ToolWindow = NULL;
+	wbmsg.sm_ArgList = 0;
+	PutMsg(&self->pr_MsgPort, &wbmsg.sm_Message);
+	ixbase = OpenLibrary("ixemul.library", 0);
+
+#if !USE_THREAD_SAFETYNET
+#warning "This code is unsafe unless if USE_THREAD_SAFETYNET is defined"
+#endif
+	mu = (struct user50 *) ix_get_long(IXID_USER, 0);
+	safe_ix_user_clone_parent(msg->parent, mu);
+	ReplyMsg(&msg->syncmsg);
+	sigsetmask(msg->sigmask);
+#endif
+
+	msg->func(msg->args);
+
+#ifdef __ixemul
+	sigsetmask(~0);
+#endif
+
+	/* free keys associated to this thread */
+	if (LIB_MINVER((struct Library *) EXEC_BASE_NAME, 51, 46))
+		TLSCallDestructors(NULL); /* NOTE: Signals are locked for ixemul above */
+	else
+		thread_cleanup();
+
+#ifdef __ixemul
+	safe_ix_user_cleanup(mu);
+
+	CloseLibrary(ixbase);
+#endif
+
+#if USE_THREAD_SAFETYNET
+	Forbid();
+	noderemove(&msg->node);
+#endif
+}
+
+/* Must be called with signals locked and Forbid() */
+static int __gthr_morphos_join_generic (struct Task *task)
+{
+	struct taskmsg *msg;
+	struct MsgPort mp;
+
+	msg = GetThreadInternal(task);
+	if(msg == NULL) {
+		/* No thread with the ID thread could be found. */
+		return ESRCH;
+	}
+
+	/* Is it a detached thread? */
+	if(msg->deathport.mp_SigBit == 0xff) {
+		/* Thread is not a joinable thread. */
+		return EINVAL;
+	}
+
+	if(msg->m.mn_ReplyPort != &msg->deathport) {
+		/* Another thread is already waiting to join with this thread. */
+		return EINVAL;
+	}
+
+	mp.mp_Node.ln_Type = NT_MSGPORT;
+	mp.mp_Flags = PA_SIGNAL;
+	mp.mp_SigBit = AllocSignal(-1);
+	if((BYTE) mp.mp_SigBit == -1) {
+		mp.mp_SigBit = SIGB_SINGLE;
+	}
+	mp.mp_SigTask = FindTask(NULL);
+	newlist((struct MinList *) &mp.mp_MsgList);
+
+	msg->m.mn_ReplyPort = &mp;
+
+	/* WaitPort() will break Forbid() as needed */
+	WaitPort(&mp);
+
+	if(mp.mp_SigBit != SIGB_SINGLE)
+		FreeSignal(mp.mp_SigBit);
+
+	return 0;
+}
+
+#if USE_THREAD_SAFETYNET
+
+static void __gthr_morphos_internal_create_cleanup(void)
+{
+	SIG_DEF
+
+	/* Join all pending threads */
+	SIG_LOCK();
+	Forbid();
+	for(;;) {
+		struct MinNode *node;
+		struct Task *task;
+
+		node = (struct MinNode *) threadlist.mlh_Head;
+		if(node->mln_Succ == NULL) {
+			/* The list is empty, we're done */
+			break;
+		}
+		task = ((struct taskmsg *) (((char *) node) - offsetof(struct taskmsg, node)))->task;
+
+		/* Note: breaks Forbid() when needed */
+		if(__gthr_morphos_join_generic(task) != 0)
+			usleep(1000000 / 100); /* On error sleep 1/100th a second */
+	}
+	Permit();
+	SIG_UNLOCK();
+}
+
+static void __gthr_morphos_internal_create_setup(void)
+{
+	if(atexit(__gthr_morphos_internal_create_cleanup) != 0)
+		exit(EXIT_FAILURE);
+}
+
+#endif
+
+int __gthr_morphos_create (__gthread_t *threadid, void *(*func) (void*),
+                           void *args)
+{
+	struct Library *DOSBase;
+	struct taskmsg *msg;
+	const struct MemList aml = {{NULL, NULL, 0, 0, NULL}, 1, {{{MEMF_CLEAR}, sizeof(*msg)}}};
+	struct MemList *ml;
+	ULONG parentppcsize, parent68ksize;
+	struct Process *proc;
+	SIG_DEF
+#ifdef __ixemul
+	struct Process *self;
+#endif
+
+#if USE_THREAD_SAFETYNET
+	{
+		static __gthread_once_t create = __GTHREAD_ONCE_INIT;
+		__gthr_morphos_once(&create, __gthr_morphos_internal_create_setup);
+	}
+#endif
+
+	SIG_LOCK();
+
+	ml = AllocEntry((struct MemList *) &aml);
+	if((IPTR) ml & (1UL << 31)) {
+		SIG_UNLOCK();
+		return EAGAIN;
+	}
+	msg = ml->ml_ME[0].me_Addr;
+	msg->ml = ml;
+	msg->m.mn_Node.ln_Type = NT_MESSAGE;
+	msg->m.mn_Node.ln_Name = msg->name; /* tested by GetThreadInternal for safety */
+	msg->m.mn_ReplyPort = &msg->deathport; /* used unless if __ghread_join is used */
+	msg->m.mn_Length = sizeof(*msg);
+	msg->deathport.mp_Node.ln_Type = NT_MSGPORT;
+	msg->deathport.mp_Flags = PA_IGNORE;
+	newlist((struct MinList *) &msg->deathport.mp_MsgList);
+	msg->func = func;
+	msg->args = args;
+#ifdef __ixemul
+	msg->parent = (struct user50 *) ix_get_long(IXID_USER, 0);
+	msg->sigmask = __omask;
+	self = (struct Process *) FindTask(NULL);
+	msg->syncmsg.mn_Node.ln_Type = NT_MESSAGE;
+	msg->syncmsg.mn_ReplyPort = &self->pr_MsgPort;
+	msg->syncmsg.mn_Length = sizeof(msg->syncmsg);
+#endif
+
+	DOSBase = OpenLibrary("dos.library", 50);
+	if(DOSBase == NULL) {
+		FreeEntry(ml);
+		SIG_UNLOCK();
+		return EAGAIN;
+	}
+
+	parentppcsize = 32768;
+	NewGetTaskAttrs(NULL, &parentppcsize, sizeof(parentppcsize), TASKINFOTYPE_STACKSIZE, TAG_DONE);
+	parent68ksize = 8192;
+	NewGetTaskAttrs(NULL, &parent68ksize, sizeof(parent68ksize), TASKINFOTYPE_STACKSIZE_M68K, TAG_DONE);
+
+#ifdef __ixemul
+	/* if some fd's are sockets, release them so the child can obtain them */
+	safe_ix_user_release_sockets(msg->parent);
+#endif
+
+#if USE_THREAD_SAFETYNET
+	Forbid();
+#endif
+
+	proc = CreateNewProcTags(NP_CodeType,     CODETYPE_PPC,
+	                         NP_Name,         (IPTR) "gthread",
+	                         NP_Entry,        (IPTR) entryfunc,
+	                         NP_PPC_Arg1,     (IPTR) msg,
+	                         NP_StartupMsg,   (IPTR) msg,
+	                         NP_PPCStackSize, parentppcsize,
+	                         NP_StackSize,    parent68ksize,
+	                         TAG_DONE);
+
+	CloseLibrary(DOSBase);
+
+	if(proc == NULL) {
+#if USE_THREAD_SAFETYNET
+		Permit();
+#endif
+		FreeEntry(ml);
+		SIG_UNLOCK();
+		return EAGAIN;
+	}
+
+#if USE_THREAD_SAFETYNET
+	msg->task = &proc->pr_Task;
+	addtail(&threadlist, &msg->node);
+	Permit();
+#endif
+
+	NewGetTaskAttrs(&proc->pr_Task, threadid, sizeof(*threadid), TASKINFOTYPE_PID, TAG_DONE);
+
+#ifdef __ixemul
+	WaitPort(&self->pr_MsgPort);
+	(void) GetMsg(&self->pr_MsgPort);
+#endif
+
+	SIG_UNLOCK();
+	return 0;
+}
+
+int __gthr_morphos_join (__gthread_t threadid, void **value_ptr)
+{
+	struct Task *task;
+	int rc;
+	SIG_DEF
+
+	if(value_ptr != NULL)
+		return ENOTSUP;
+
+	SIG_LOCK();
+	Forbid();
+
+	task = FindTaskByPID(threadid);
+	if(task == NULL) {
+		Permit();
+		SIG_UNLOCK();
+		return 0;
+	}
+
+	if(task == FindTask(NULL)) {
+		Permit();
+		/* Joining self would deadlock anyway. */
+		SIG_UNLOCK();
+		return EDEADLK;
+	}
+
+	rc = __gthr_morphos_join_generic(task);
+
+	Permit();
+	SIG_UNLOCK();
+	return rc;
+}
+
+int __gthr_morphos_detach (__gthread_t threadid)
+{
+	struct Task *task;
+	struct taskmsg *msg;
+	SIG_DEF
+
+	SIG_LOCK();
+	Forbid();
+
+	task = FindTaskByPID(threadid);
+	if(task == NULL) {
+		Permit();
+		SIG_UNLOCK();
+		return ESRCH;
+	}
+
+	msg = GetThreadInternal(task);
+	if(msg == NULL || msg->deathport.mp_SigBit == 0xff || msg->m.mn_ReplyPort != &msg->deathport) {
+		Permit();
+		/* Thread is not a joinable thread. */
+		SIG_UNLOCK();
+		return EINVAL;
+	}
+
+	msg->deathport.mp_SigBit = 0xff;
+
+	Permit();
+	SIG_UNLOCK();
+	return 0;
+}
+
+int __gthr_morphos_equal (__gthread_t t1, __gthread_t t2)
+{
+	return t1 == t2;
+}
+
+__gthread_t __gthr_morphos_self (void)
+{
+	__gthread_t threadid;
+	SIG_DEF
+
+	SIG_LOCK();
+	NewGetTaskAttrs(NULL, &threadid, sizeof(threadid), TASKINFOTYPE_PID, TAG_DONE);
+	SIG_UNLOCK();
+	return threadid;
+}
+
+int __gthr_morphos_yield (void)
+{
+	SIG_DEF
+
+	SIG_LOCK();
+	Forbid();
+	Permit(); /* Permit() causes a reschedule */
+	SIG_UNLOCK();
+	return 0;
+}
+
+/* Cond */
+
+void __gthr_morphos_cond_init_function (__gthread_cond_t *_gthr_cond)
+{
+	__internal_cond_t *__cond = (__internal_cond_t *) _gthr_cond;
+	SIG_DEF
+
+	_D("<%s/%s():%lu> __gthread_cond_t == 0x%p\n", __FILE__, __FUNCTION__, __LINE__, __cond);
+
+	if(__cond == NULL) {
+		return;
+	}
+
+	SIG_LOCK();
+	InitSemaphore(&__cond->u1.__sem);
+	SIG_UNLOCK();
+	newlist(&__cond->u2.__waiters);
+}
+
+int __gthr_morphos_cond_destroy (__gthread_cond_t *_gthr_cond)
+{
+	__internal_cond_t *__cond = (__internal_cond_t *) _gthr_cond;
+	SIG_DEF
+
+	_D("<%s/%s():%lu> __gthread_cond_t == 0x%p\n", __FILE__, __FUNCTION__, __LINE__, __cond);
+
+	if(__cond == NULL) {
+		_D("<%s/%s():%lu> == EINVAL\n", __FILE__, __FUNCTION__, __LINE__);
+		return EINVAL;
+	}
+
+	if(SemaphoreIsInvalid(&__cond->u1.__sem)) {
+		/* static cond not yet initialized, so do nothing */
+		return 0;
+	}
+
+	SIG_LOCK();
+
+	if(!AttemptSemaphore(&__cond->u1.__sem)) {
+		SIG_UNLOCK();
+		return EBUSY;
+	}
+
+	if(!IsListEmpty((struct List *)&__cond->u2.__waiters)) {
+		ReleaseSemaphore(&__cond->u1.__sem);
+		SIG_UNLOCK();
+		return EBUSY;
+	}
+
+	memset(&__cond->u1.__sem, 0, sizeof(__cond->u1.__sem));
+	__gthr_morphos_cond_init_function(_gthr_cond);
+
+	_D("<%s/%s():%lu> == 0\n", __FILE__, __FUNCTION__, __LINE__);
+
+	SIG_UNLOCK();
+	return 0;
+}
+
+struct CondWaiter {
+	struct MinNode node;
+	struct Task *task;
+	ULONG sigmask;
+};
+
+static int __gthr_morphos_cond_broadcast_generic (__gthread_cond_t *_gthr_cond, int onlyfirst)
+{
+	__internal_cond_t *__cond = (__internal_cond_t *) _gthr_cond;
+	struct CondWaiter *waiter;
+	SIG_DEF
+
+	if(__cond == NULL) {
+		return EINVAL;
+	}
+
+	SIG_LOCK();
+
+	/* initialize static cond */
+	Forbid();
+	if(SemaphoreIsInvalid(&__cond->u1.__sem))
+		__gthr_morphos_cond_init_function(_gthr_cond);
+	Permit();
+
+	/* signal the waiting threads */
+	ObtainSemaphoreShared(&__cond->u1.__sem);
+
+	for(waiter = (struct CondWaiter *) __cond->u2.__waiters.mlh_Head;
+	    waiter->node.mln_Succ;
+	    waiter = (struct CondWaiter *) waiter->node.mln_Succ) {
+		Signal(waiter->task, waiter->sigmask);
+		if(onlyfirst)
+			break;
+	}
+
+	ReleaseSemaphore(&__cond->u1.__sem);
+
+	SIG_UNLOCK();
+	return 0;
+}
+
+int __gthr_morphos_cond_broadcast (__gthread_cond_t *_gthr_cond)
+{
+	return __gthr_morphos_cond_broadcast_generic (_gthr_cond, 0);
+}
+
+int __gthr_morphos_cond_timedwait (__gthread_cond_t *_gthr_cond,
+                                   __gthread_mutex_t *_gthr_mutex,
+                                   const __gthread_time_t *abs_timeout)
+{
+	__internal_cond_t *__cond = (__internal_cond_t *) _gthr_cond;
+	__internal_mutex_t *__mutex = (__internal_mutex_t *) _gthr_mutex;
+	struct CondWaiter waiter;
+	BYTE signal;
+	struct Task *self;
+	struct MsgPort mp;
+	struct timerequest tr;
+	int rc = 0;
+	SIG_DEF
+
+	if(__cond == NULL || __mutex == NULL) {
+		return EINVAL;
+	}
+
+	if(abs_timeout && (abs_timeout->tv_sec < 0 || abs_timeout->tv_nsec < 0 ||
+	                   abs_timeout->tv_nsec > 999999999)) {
+		return EINVAL;
+	}
+
+	SIG_LOCK();
+
+	Forbid();
+	/* initialize static cond & mutex */
+	if(SemaphoreIsInvalid(&__cond->u1.__sem))
+		__gthr_morphos_cond_init_function(_gthr_cond);
+	if(SemaphoreIsInvalid(&__mutex->u.__sem))
+		__gthr_morphos_mutex_init_function(_gthr_mutex);
+	Permit();
+
+	signal = AllocSignal(-1);
+	if(signal == -1) {
+		signal = SIGBREAKB_CTRL_F;
+		SetSignal(1UL << signal, 0);
+	}
+
+	self = FindTask(NULL);
+
+	if(abs_timeout) {
+		mp.mp_Node.ln_Type = NT_MSGPORT;
+		mp.mp_Flags = PA_SIGNAL;
+		mp.mp_SigBit = signal;
+		mp.mp_SigTask = self;
+		newlist((struct MinList *) &mp.mp_MsgList);
+
+		tr.tr_node.io_Message.mn_Node.ln_Type = NT_REPLYMSG;
+		tr.tr_node.io_Message.mn_ReplyPort = &mp;
+		tr.tr_node.io_Message.mn_Length = sizeof(tr);
+
+		if(OpenDevice(TIMERNAME, UNIT_WAITUTC, (APTR) &tr, 0) != 0) {
+			if(signal != SIGBREAKB_CTRL_F)
+				FreeSignal(signal);
+			SIG_UNLOCK();
+			return ENOTSUP;
+		}
+
+		tr.tr_node.io_Command = TR_ADDREQUEST;
+		tr.tr_time.tv_secs  = abs_timeout->tv_sec;
+		tr.tr_time.tv_micro = abs_timeout->tv_nsec / 1000;
+		UNIXTIME_TO_AMIGATIME(&tr.tr_time, &tr.tr_time);
+		SendIO((APTR) &tr);
+	}
+
+	/* prepare a waiter node */
+	waiter.task = self;
+	waiter.sigmask = 1UL << signal;
+
+	/* add it to the end of the list */
+        ObtainSemaphore(&__cond->u1.__sem);
+	addtail(&__cond->u2.__waiters, &waiter.node);
+	ReleaseSemaphore(&__cond->u1.__sem);
+
+	/* wait for the condition to be signalled or the timeout */
+	__mutex->incond++;
+	__gthr_morphos_mutex_unlock(_gthr_mutex);
+
+	Wait(1UL << signal);
+
+	__gthr_morphos_mutex_lock(_gthr_mutex);
+	__mutex->incond--;
+
+	/* remove the node from the list */
+	ObtainSemaphore(&__cond->u1.__sem);
+	noderemove(&waiter.node);
+	ReleaseSemaphore(&__cond->u1.__sem);
+
+	if(abs_timeout) {
+		if(CheckIO((APTR) &tr))
+			rc = ETIMEDOUT;
+		else {
+			AbortIO((APTR) &tr);
+			WaitIO((APTR) &tr);
+		}
+
+		CloseDevice((APTR) &tr);
+	}
+
+	if(signal != SIGBREAKB_CTRL_F)
+		FreeSignal(signal);
+
+	SIG_UNLOCK();
+	return rc;
+}
+
+int __gthr_morphos_cond_wait (__gthread_cond_t *_gthr_cond, __gthread_mutex_t *_gthr_mutex)
+{
+	return __gthr_morphos_cond_timedwait (_gthr_cond, _gthr_mutex, NULL);
+}
+
+int __gthr_morphos_cond_wait_recursive (__gthread_cond_t *_gthr_cond,
+                                        __gthread_recursive_mutex_t *_gthr_mutex)
+{
+	return __gthr_morphos_cond_timedwait (_gthr_cond, (__gthread_mutex_t *) _gthr_mutex, NULL);
+}
+
+int __gthr_morphos_cond_signal (__gthread_cond_t *_gthr_cond)
+{
+	return __gthr_morphos_cond_broadcast_generic (_gthr_cond, 1);
+}
+
+#ifndef HIDE_EXPORTS
+#pragma GCC visibility pop
+#endif
+
+#if TESTME
+
+#if !USE_THREAD_SAFETYNET
+struct Library *SocketBase;
+#include <unistd.h>
+#endif
+
+void dprintf(const char *, ...);
+
+__gthread_once_t once = __GTHREAD_ONCE_INIT;
+__gthread_mutex_t mutex = __GTHREAD_MUTEX_INIT;
+__gthread_recursive_mutex_t rmutex = __GTHREAD_RECURSIVE_MUTEX_INIT;
+__gthread_cond_t cond = __GTHREAD_COND_INIT;
+__gthread_key_t key;
+
+void *func(void *parm)
+{
+	void *value;
+	int rc;
+
+	dprintf("thread parm %p\n", parm);
+
+	value = __gthread_getspecific(key);
+	if (value != NULL)
+		dprintf("unexpected key %p value %p (%s)\n", key, value, value);
+
+	if (__gthread_setspecific(key, "lollero") != 0)
+		dprintf("__gthread_setspecific failed when it shouldn't have\n");
+
+	value = __gthread_getspecific(key);
+	dprintf("key %p value %p (%s)\n", key, value, value);
+
+	__gthread_mutex_lock(&mutex);
+	sleep(2);
+	__gthread_mutex_unlock(&mutex);
+	if (__gthread_mutex_trylock(&mutex) == 0)
+		dprintf("__gthread_mutex_trylock succeeded when it shouldn't have\n");
+
+	dprintf("obtain the mutex %p...\n", &mutex);
+	__gthread_mutex_lock(&mutex);
+	dprintf("thread waiting for cond %p for up to 5 seconds...\n", &cond);
+	const __gthread_time_t timeout = {time(NULL) + 5, 0};
+	rc = __gthread_cond_timedwait(&cond, &mutex, &timeout);
+	if (rc == 0)
+		dprintf("thread got cond %p...\n", &cond);
+	else if (rc == ETIMEDOUT)
+		dprintf("unexpected timeout cond %p\n", &cond);
+	else
+		dprintf("unexpected cond %p error %d\n", &cond, rc);
+	__gthread_mutex_unlock(&mutex);
+
+	dprintf("thread done\n");
+	return NULL;
+}
+
+void destructor(void *value)
+{
+	dprintf("destructor called with %p <%s>\n", value, value);
+}
+
+void *func2(void *ptr)
+{
+	int f = (int) ptr;
+	dprintf("thread2 started\n");
+	write(f, "2\n", 2);
+	sleep(1);
+	dprintf("thread2 done\n");
+	write(f, "3\n", 2);
+	return NULL;
+}
+
+void oncefunc(void)
+{
+	static int counter;
+	dprintf("oncefunc called\n");
+	if (counter == 1)
+		dprintf("oncefunc unexpectedly called more than once\n");
+	counter++;
+}
+
+int main(void)
+{
+	int rc;
+	__gthread_t id;
+
+	/* test __gthread_once */
+	__gthread_once(&once, oncefunc);
+	__gthread_once(&once, oncefunc);
+
+	/* test recursion on recursive mutex */
+	rc = __gthread_recursive_mutex_lock(&rmutex);
+	if (rc != 0) {
+		dprintf("failed to __gthread_recursive_mutex_lock\n");
+		return 0;
+	}
+	rc = __gthread_recursive_mutex_lock(&rmutex);
+	if (rc != 0) {
+		dprintf("__gthread_recursive_mutex_lock failed when it should have succeeded\n");
+		return 0;
+	}
+	__gthread_recursive_mutex_unlock(&rmutex);
+	__gthread_recursive_mutex_unlock(&rmutex);
+
+	/* test recursion on non-recursive mutex */
+	rc = __gthread_mutex_lock(&mutex);
+	if (rc != 0) {
+		dprintf("failed to __gthread_mutex_lock\n");
+		return 0;
+	}
+	rc = __gthread_mutex_lock(&mutex);
+	if (rc == 0) {
+		dprintf("__gthread_mutex_lock succeeded when it should have failed\n");
+		return 0;
+	}
+	__gthread_mutex_unlock(&mutex);
+
+	/* test key (see thread) */
+	if (__gthread_key_create(&key, destructor) != 0) {
+		dprintf("failed to __gthread_key_create\n");
+		return 0;
+	}
+
+#if !USE_THREAD_ONLY_SETSPECIFIC
+	if (__gthread_setspecific(key, "mainapp") != 0)
+		dprintf("__gthread_setspecific in main app failed when it shouldn't have\n");
+	dprintf("__gthread_getspecific <%s>\n", __gthread_getspecific(key));
+#endif
+
+	dprintf("main process - func %p\n", func);
+	if (__gthread_create(&id, func, func) == 0) {
+		const time_t t = time(NULL);
+		const __gthread_time_t t1 = {t+1,0};
+		usleep(100000);
+		rc = __gthread_mutex_timedlock(&mutex, &t1);
+		dprintf("__gthread_mutex_timedlock 1 %d\n", rc);
+		if (rc != 0) {
+			const __gthread_time_t t2 = {t+2,0};
+			rc = __gthread_mutex_timedlock(&mutex, &t2);
+			dprintf("__gthread_mutex_timedlock 2 %d\n", rc);
+			if (rc != 0) {
+				const __gthread_time_t t3 = {t+3,0};
+				rc = __gthread_mutex_timedlock(&mutex, &t3);
+				dprintf("__gthread_mutex_timedlock 3 %d\n", rc);
+				if (rc == 0) {
+					sleep(1);
+					__gthread_mutex_unlock(&mutex);
+					usleep(100000);
+					dprintf("signaling cond %p\n", &cond);
+					__gthread_cond_signal(&cond);
+				}
+				else
+					dprintf("__gthread_mutex_timedlock failed when it shouldn't have\n");
+			}
+			else
+				dprintf("__gthread_mutex_timedlock 2 unexpectedly succeeded\n");
+		}
+		else
+			dprintf("__gthread_mutex_timedlock 1 unexpectedly succeeded\n");
+
+		dprintf("before join threadid %d\n", id);
+		rc = __gthread_join(id, NULL);
+		dprintf("after join rc %d\n", rc);
+	}
+	else
+		dprintf("__gthread_create failed unexpectedly\n");
+
+	dprintf("launch a second thread\n");
+	int f = 1; //open("/t/out", O_WRONLY|O_CREAT, 0);
+	write(f, "1\n", 2);
+	if (__gthread_create(&id, func2, (void *) f) == 0)
+	{
+		dprintf("before join threadid %d\n", id);
+		write(f, "4\n", 2);
+		rc = __gthread_join(id, NULL);
+		dprintf("after join rc %d\n", rc);
+		write(f, "5\n", 2);
+	}
+	else
+		dprintf("__gthread_create failed unexpectedly\n");
+
+	//close(f);
+
+	__gthread_key_delete(key);
+}
+#endif
